#!/usr/bin/perl -w  # -*- cperl -*- #
#
#  dmesg.pm - Handle the "dmesg" commands.
#
#  Steve Kemp
#  ---
#  http://www.steve.org.uk/
#
#


#
#  The package this module is implementing.
#
package Xen::Monitor::Plugins::dmesg;


#
#  Register the plugin.
#
Xen::Monitor::Server::register_plugin("Xen::Monitor::Plugins::dmesg");



#
#  Minimal constructor.
#
sub new { return bless {}; }



#
#  Return the author of this plugin.
#
sub getAuthor
{
    return( 'Steve Kemp <steve@steve.org.uk>' );
}


#
#  Does this plugin require authentication?
#
sub needsAuth
{
    return 0;
}

#
#  Return the commands we handle.
#
sub getCommand
{
    my %commands;
    $commands{"dmesg"} = 1;
    return( %commands );
}


#
# Run the command we're sent - this means 'start' or 'stop'.
#
sub runCommand
{
    my ( $class, $server, $command, @args ) = ( @_ );

    my $monitor	= Xen::Monitor->new();
    my @dmesg	= $monitor->getDMESG();

    print "200 OK\r\n";

    foreach my $line ( @dmesg )
    {
	chomp( $line );
	print $line . "\r\n";
    }

    print "300 DONE\r\n";
}


1;
